#property copyright "Copyright  2011, ClusterDelta.com"
#property link      "http://my.clusterdelta.com/volumeprofile_mt4"
#property description   "ClusterDelta Volume Profile, Expert version"

#include <stdlib.mqh>

#import  "Wininet.dll"
   int InternetOpenW(string, int, string, string, int);
   int InternetConnectW(int, string, int, string, string, int, int, int); 
   int HttpOpenRequestW(int, string, string, int, string, int, string, int); 
   int InternetOpenUrlW(int, string, string, int, int, int);
   int InternetReadFile( int hFile, int& lpvBuffer[], int lNumBytesToRead, int& lNumberOfBytesRead[] );
   int InternetCloseHandle(int); 
#import

#define MAGICCVP 20151008

//---- input parameters
extern string Comment_Instrument="--- Futures Ticker or AUTO ";
extern string Instrument="AUTO";
extern string MetaTrader_GMT="AUTO";
extern int    UPDATE_TIME_IN_SEC=30;
extern string Comment_Profile_Period_ = "(0-Custom, 1-Hour, 2-Day, 3-Week, ";
extern string Comment_Profile_Period__ ="4-Asia, 5-Eur, 6-Nyse, 7-CME, 8-Cont)";

extern string CHART_PROFILES = " ==== Chart Profiles Settings ==== ";
extern bool Display_Chart_Profiles = true;
extern int Amount_of_Profiles=1;
extern int Profile_Period = 2;
extern datetime Custom_Start_time=D'2012.01.01 00:00';
extern datetime Custom_End_time=D'2012.01.01 00:00';
extern int Minutes_Between_Profiles=0;
extern color Chart_LineColor_in_VA=LightGray;
extern color Chart_LineColor_Max_Volume=Red;
extern color Chart_LineColor_out_VA=Gray;
extern int Chart_LineColor_Width=1;
extern string RIGHT_PROFILE = " ==== Right Profile Setting ==== ";
extern bool Display_Right_Profile = true;
extern int Right_Profile_Period = 3;
extern datetime Right_Custom_Start_time=D'2012.01.01 00:00';
extern datetime Right_Custom_End_time=D'2012.01.01 00:00';
extern color Right_LineColor_in_VA=SkyBlue; 
extern color Right_LineColor_Max_Volume=Red;
extern color Right_LineColor_out_VA=DodgerBlue;
extern int   Right_LineColor_Width=1;
extern string LEFT_PROFILE = " ==== Left Profile Setting ==== ";
extern bool Display_Left_Profile = false;
extern int Left_Profile_Period = 8;
extern datetime Left_Custom_Start_time=D'2012.01.01 00:00';
extern datetime Left_Custom_End_time=D'2012.01.01 00:00';
extern color Left_LineColor_in_VA=SkyBlue;  
extern color Left_LineColor_Max_Volume=Red;
extern color Left_LineColor_out_VA=DodgerBlue;
extern int   Left_LineColor_Width=1;
extern string Comment_COMMON_Settings = " ==== Common Settings ==== ";
extern int Forex_shift=0;
extern int ZOOM_scale_in_percent=60;
extern int Correlate_Volume_To=0;
extern bool ReverseChart=false;
extern int PriceMultiplier=1;
extern bool Draw_as_Background=true;
extern double Max_Volume_k=0.85;
extern bool Draw_POC_Continious=false;
extern int Continious_line_style=2;

string ver = "ver 3.1";
string MessageFromServer="                                                                                     ";

datetime myUpdateTime=0;
int UpdateFreq=60; // sec

string HASH_IND=" ";

double PriceData[];
double ValueData[];

double RightPriceData[];
double RightValueData[];

double LeftPriceData[];
double LeftValueData[];

datetime last_Start_time;
datetime last_End_time;

datetime Left_last_Start_time;
datetime Left_last_End_time;
datetime Right_last_Start_time;
datetime Right_last_End_time;


bool loaded=false;
int CHART_CHANGED_REASON_1 = 0; //WindowBarsPerChart();
int CHART_CHANGED_REASON_2 = 0; //WindowFirstVisibleBar();
long CHART_CHANGED_REASON_3 = 0; //x
long CHART_CHANGED_REASON_4 = 0; //y
long cx=0;
long cy=0;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
{
 
   if (UPDATE_TIME_IN_SEC>=15) { UpdateFreq=UPDATE_TIME_IN_SEC; }   
   HASH_IND=TimeLocal()+""+DoubleToStr(MathAbs(MathRand()*10000000),0);  
   
   //if(VP_Position>0) { Amount_of_Profiles=1; }
   if(Amount_of_Profiles<1 || Amount_of_Profiles>60) { Amount_of_Profiles=1; }
   if (Profile_Period<0 || Profile_Period>8) { Profile_Period=2; }
   if (Profile_Period==8) { Amount_of_Profiles=1; }
   EventSetTimer(10);
   OnTick();
   return;
   
  }
void OnTimer()
{
  OnTick();
}
void OnChartEvent(const int id,         //     
                  const long& lparam,   //    long 
                  const double& dparam, //    double 
                  const string& sparam  //    string 
)
{
   ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,cx);
   ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,cy);   
  
   if (loaded && (CHART_CHANGED_REASON_1 != WindowBarsPerChart() || CHART_CHANGED_REASON_2 != WindowFirstVisibleBar() || CHART_CHANGED_REASON_3!=cx || CHART_CHANGED_REASON_4!=cy))
   {
     if(Display_Right_Profile) { DrawVP(RightPriceData,RightValueData,Correlate_Volume_To,2); }
     if(Display_Left_Profile) { DrawVP(LeftPriceData,LeftValueData,Correlate_Volume_To,1); }

     CHART_CHANGED_REASON_1 = WindowBarsPerChart();
     CHART_CHANGED_REASON_2 = WindowFirstVisibleBar();
     if(!ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,CHART_CHANGED_REASON_3)) { return;  }
     if(!ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,CHART_CHANGED_REASON_4))  { return;  }  
     
     
  }
 
  Comment("ClusterDelta Experts Set: VolumeProfile Expert "+ver+"\nhttp://my.clusterdelta.com/experts/volumeprofile\n"+"Chart Profile: "+chart_type(Profile_Period,Display_Chart_Profiles) +
  "\nLeft Border Profile: "+chart_type(Left_Profile_Period, Display_Left_Profile)+"\nRight Border Profile: "+chart_type(Right_Profile_Period,Display_Right_Profile)+"\n\nPress F7 to change settings");
  

}  
  
string chart_type(int n, bool e)
{
  if(e==false) return "None";
  if(n==0) return "Custom";
  if(n==1) return "Hour";
  if(n==2) return "Day";
  if(n==3) return "Week";
  if(n==4) return "Asia";
  if(n==5) return "Europe";
  if(n==6) return "NYSE";
  if(n==7) return "NYSE";
  if(n==8) return "Contract";
  return "Unknown";
}  
  
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
void OnTick()
  {
   static int dllalert=0;
   
   
   if (!IsDllsAllowed() ) { if (!dllalert) Alert("You have to allow DLL Import calls!"); dllalert=1; return; }
   

   int Counted_bars = IndicatorCounted();
   int err=0;
   int count = 0;
   
   
   ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,cx);
   ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,cy);   
  
   if (loaded && (CHART_CHANGED_REASON_1 != WindowBarsPerChart() || CHART_CHANGED_REASON_2 != WindowFirstVisibleBar() || CHART_CHANGED_REASON_3!=cx || CHART_CHANGED_REASON_4!=cy))
   {
     // redraw VP
     //if(Display_Chart_Profiles) { DrawVP(min_price,ChartPriceData,ChartValueData,Correlate_Volume_To,0); }
     if(Display_Right_Profile) { DrawVP(RightPriceData,RightValueData,Correlate_Volume_To,2); }
     if(Display_Left_Profile) { DrawVP(LeftPriceData,LeftValueData,Correlate_Volume_To,1); }
     CHART_CHANGED_REASON_1 = WindowBarsPerChart();
     CHART_CHANGED_REASON_2 = WindowFirstVisibleBar();
     if(!ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,CHART_CHANGED_REASON_3)) { return;  }
     if(!ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,CHART_CHANGED_REASON_4))  { return;  }  
   
   }
      
   if (TimeLocal() < myUpdateTime && loaded) { return; } else 
   { 
      myUpdateTime = TimeLocal() + UpdateFreq; 
   }
   

   
   if(Display_Chart_Profiles) { GetData(0); }
   if(Display_Right_Profile) { GetData(2); }     
   if(Display_Left_Profile) { GetData(1); }          
   
   loaded=true;
   myUpdateTime = TimeLocal() + UpdateFreq;

   //----
   return;
  }
//+------------------------------------------------------------------+

void OnDeinit(const int reason)
{

  int    obj_total=ObjectsTotal();
  for(int i=0;i<obj_total;i++)
    {
     while ((StringSubstr(ObjectName(i),0,7) == "VPLine_") && (StringFind(ObjectName(i),HASH_IND)!= -1)) { ObjectDelete(ObjectName(i));  }
    }
  loaded=false;
  return;
}


int GetData(int Position)
{
   
   string Buffer = " ";
   string response="";
   int cBuffer[256];
   string request="";

   if(Position == 0) { request =   "http://clusterdelta.com/mt4/vp2.php?symbol="+UrlEncode(Symbol()) +"&static="+Profile_Period+"&amount="+(Amount_of_Profiles-1)+"&between="+Minutes_Between_Profiles+"&starttime="+TimeToStr(Custom_Start_time)+"&endtime="+TimeToStr(Custom_End_time)+"&usertime="+TimeToStr(TimeCurrent())+"&instrument="+UrlEncode(Instrument)+"&lastloaded=&mtgmt="+MetaTrader_GMT+"&ver="+UrlEncode(ver); }
   if(Position == 1) { request =   "http://clusterdelta.com/mt4/vp2.php?symbol="+UrlEncode(Symbol()) +"&static="+Left_Profile_Period+"&amount=0&between=0&starttime="+TimeToStr(Left_Custom_Start_time)+"&endtime="+TimeToStr(Left_Custom_End_time)+"&usertime="+TimeToStr(TimeCurrent())+"&instrument="+UrlEncode(Instrument)+"&lastloaded=&mtgmt="+MetaTrader_GMT+"&ver="+UrlEncode(ver); }   
   if(Position == 2) { request =   "http://clusterdelta.com/mt4/vp2.php?symbol="+UrlEncode(Symbol()) +"&static="+Right_Profile_Period+"&amount=0&between=0&starttime="+TimeToStr(Right_Custom_Start_time)+"&endtime="+TimeToStr(Right_Custom_End_time)+"&usertime="+TimeToStr(TimeCurrent())+"&instrument="+UrlEncode(Instrument)+"&lastloaded=&mtgmt="+MetaTrader_GMT+"&ver="+UrlEncode(ver); }      
    int valid=0;   
    int HttpOpen = InternetOpenW(" ", 0, " "," ",0 ); 
    //int HttpConnect = InternetConnectW(HttpOpen, "", 80, "", "", 3, 0, 1); 
    int HttpRequest = InternetOpenUrlW(HttpOpen,request, NULL, 0, 0, 0);
    int cur_str_index = 0;   
    int read[1];
   
    while (true)
    {
        InternetReadFile(HttpRequest, cBuffer, 1024, read);
        if(read[0] == 0)break;
        string text = "";   
        for(int i = 0; i < 256; i++){
                        text = text + CharToStr(cBuffer[i] & 0x000000FF);
                        if(StringLen(text) == read[0])break;
                        text = text + CharToStr((cBuffer[i] >> 8) & 0x000000FF);
                        if(StringLen(text) == read[0])break;
                        text = text + CharToStr((cBuffer[i] >> 16) & 0x000000FF);
                        if(StringLen(text) == read[0])break;
                        text = text + CharToStr((cBuffer[i] >> 24) & 0x000000FF);
                        if(StringLen(text) == read[0])break;
                }
        response = response + text;
        Sleep(1);      
    }
 
    if (HttpRequest > 0) InternetCloseHandle(HttpRequest); 
    //if (HttpConnect > 0) InternetCloseHandle(HttpConnect); 
    if (HttpOpen > 0) InternetCloseHandle(HttpOpen);  
    Sleep(1);
   
     if(Position == 0) { valid = ConvertResponseToArrays(response,PriceData,ValueData,"\n",";",MessageFromServer, last_Start_time, last_End_time); }
     if(Position == 1) { valid = ConvertResponseToArrays(response,LeftPriceData,LeftValueData,"\n",";",MessageFromServer, Left_last_Start_time, Left_last_End_time); }     
     if(Position == 2) { valid = ConvertResponseToArrays(response,RightPriceData,RightValueData,"\n",";",MessageFromServer, Right_last_Start_time, Right_last_End_time); }          

   if (valid>0)
   {
     
     if (ReverseChart) //  
     {
          if(Position == 0) { ReversePrices(PriceData,false,1); }
          if(Position == 1) { ReversePrices(LeftPriceData,false,1); }
          if(Position == 2) { ReversePrices(RightPriceData,false,1); }
     }
     if (PriceMultiplier!=1)
     {
       ReversePrices(PriceData,true,PriceMultiplier);
          if(Position == 0) { ReversePrices(PriceData,true,PriceMultiplier); }
          if(Position == 1) { ReversePrices(LeftPriceData,true,PriceMultiplier); }
          if(Position == 2) { ReversePrices(RightPriceData,true,PriceMultiplier); }
     }
     if(Position == 0)
     {
       SortDictionary(PriceData,ValueData,MODE_ASCEND,1);
       DrawVP(PriceData,ValueData,Correlate_Volume_To,Position); //price,max_volume,next_price,0);
     }
     if(Position == 1)
     {
       SortDictionary(LeftPriceData,LeftValueData,MODE_ASCEND,1);
       DrawVP(LeftPriceData,LeftValueData,Correlate_Volume_To,Position); //price,max_volume,next_price,0);
     }
     if(Position == 2)
     {
       SortDictionary(RightPriceData,RightValueData,MODE_ASCEND,1);
       DrawVP(RightPriceData,RightValueData,Correlate_Volume_To,Position); //price,max_volume,next_price,0);
     }
   } 
   if (StringLen(MessageFromServer)>10) 
   {
     Comment("Volume Profile Expert Message: "+MessageFromServer); 
   } else {  Comment(""); }
 
   
   if(Amount_of_Profiles>1 && Position==0) { Amount_of_Profiles--; GetData(0); }
   else
   {
     if (last_End_time < Time[0])
     {
       //Print ("Online MODE is off. End_time in the history");
  
     }
   
   
   }
   return (0);
}

void DrawVP(double &prices[], double &volumes[], double Correlate_Volume, int VP_Position)
{
int i=0;
double arrprice;
double arrvol;
//datetime drawtime =  Start_time;
datetime drawrange; // = End_time;
int volrange;
double next_price;
int start_index, end_index;

double val=0, vah=0;

if(ArraySize(volumes)==0) return;

int    max_volume_index = ArrayMaximum(volumes);
double mymax_volume = volumes[max_volume_index];
double max_volume_price = prices[max_volume_index];

check_VA(val,vah,max_volume_price,max_volume_index,prices,volumes);


int last_bar = (WindowFirstVisibleBar() - WindowBarsPerChart());
int empty_space =0 ;
datetime last_date;
int end_shift=0;


if (last_bar < 0)
{
  empty_space = WindowBarsPerChart() - WindowFirstVisibleBar();
  last_date=Time[0]+60*Period()*empty_space;
} else
{
  last_date=Time[last_bar];
}


int zoom = 100;

if (ZOOM_scale_in_percent > 2 && ZOOM_scale_in_percent < 200) { zoom = ZOOM_scale_in_percent; }
if (zoom>300) zoom=300;
if (zoom<2) zoom=2;

double calc_max_volume = mymax_volume;
if (Correlate_Volume>0)
{
  if ((mymax_volume*1.0 / Correlate_Volume ) < 5)  { calc_max_volume = Correlate_Volume; }
}

for (i=0; i<ArraySize(prices); i++)
{
  arrprice = prices[i];
  arrvol   = volumes[i];   
  next_price = arrprice + 1/MathPow(10,Digits);   

  if (VP_Position == 0)
  {
     
     int s = ArrayBsearch(Time,last_Start_time,WHOLE_ARRAY,0,MODE_DESCEND);
     //Start_time = Time[s];
     start_index = s;
     if (last_End_time<=Time[0])
     {
       s = ArrayBsearch(Time,last_End_time,WHOLE_ARRAY,0,MODE_DESCEND);
     } else { s =0; }
     
     end_index = s;

    //      
    volrange =  MathRound(((start_index-end_index)*arrvol*1.0*zoom) /(calc_max_volume*100));
    drawrange = Time[start_index - volrange]; // * Period() * 60;
    DrawVPLine(arrprice, next_price, Time[start_index], drawrange, arrvol, mymax_volume, val, vah, last_date, VP_Position);
  } else
  if (VP_Position == 2) //  
  {
    end_shift= WindowBarsPerChart()/5;
    volrange =  MathRound((end_shift*arrvol*1.0*zoom) /(calc_max_volume*100));
    drawrange = last_date - volrange * Period() * 60;
    if (drawrange < Time[0])
    {
      end_shift = ArrayBsearch(Time,drawrange,WHOLE_ARRAY,0,MODE_DESCEND);
    }
    DrawVPLine(arrprice, next_price, last_date, drawrange, arrvol, mymax_volume, val, vah, last_date, VP_Position);
  }
  else
  if (VP_Position == 1) //  
  {
    end_shift = WindowBarsPerChart()/5;
    volrange =  MathRound((end_shift*arrvol*1.0*zoom) /(calc_max_volume*100));
    
    if ( (WindowFirstVisibleBar() - volrange)  >= 0)
    {
      drawrange = Time[WindowFirstVisibleBar() - volrange];
    } else
    {
      drawrange = last_date + volrange * Period() * 60; 
    }
    DrawVPLine(arrprice, next_price, Time[WindowFirstVisibleBar()], drawrange, arrvol, mymax_volume, val, vah, last_date, VP_Position);
  }

}



}

void DrawVPLine(double mypr, double mynext_price, datetime mydrawtime, datetime mydrawrange, double myvol, double mymaxvol, double Val, double Vah, datetime mylastdate, int VP_Position)
{  
   int showvol=myvol;
   double myprice = mypr+Forex_shift*Point;
   string rec_name="VPLine_P"+myprice+"_vp"+Amount_of_Profiles+""+mydrawtime+"_hash"+HASH_IND;
   color LineColor_in_VA;
   color LineColor_Max_Volume;
   color LineColor_out_VA;
   int   LineColor_Width;
   
   if (VP_Position>0)
   {
     rec_name="VPLine_P"+myprice+"_hash"+VP_Position+HASH_IND;
   }
   if (VP_Position==0) { LineColor_Max_Volume=Chart_LineColor_Max_Volume; LineColor_in_VA=Chart_LineColor_in_VA; LineColor_out_VA=Chart_LineColor_out_VA; LineColor_Width=Chart_LineColor_Width; }
   if (VP_Position==1) { LineColor_Max_Volume=Left_LineColor_Max_Volume; LineColor_in_VA=Left_LineColor_in_VA; LineColor_out_VA=Left_LineColor_out_VA; LineColor_Width=Left_LineColor_Width; }
   if (VP_Position==2) { LineColor_Max_Volume=Right_LineColor_Max_Volume; LineColor_in_VA=Right_LineColor_in_VA; LineColor_out_VA=Right_LineColor_out_VA; LineColor_Width=Right_LineColor_Width; }
   
   //ObjectCreate(rec_name,OBJ_RECTANGLE,0,mydrawtime,myprice,mydrawrange,mynext_price);
   ObjectGet(rec_name,OBJPROP_COLOR);// 
   int Error=GetLastError();               //      
   if (Error!=4202) { ObjectDelete(rec_name);  }
   
   ObjectCreate(rec_name,OBJ_TREND,0,mydrawtime,myprice,mydrawrange,myprice);
   ObjectSet(rec_name,OBJPROP_RAY, false);
   
   if ( (myvol*1.0 / mymaxvol) >= Max_Volume_k)
   {
     ObjectSet(rec_name,OBJPROP_COLOR,LineColor_Max_Volume); 
     if (Draw_POC_Continious == true)
     {
       ObjectSet(rec_name,OBJPROP_TIME2,mylastdate);
       ObjectSet(rec_name,OBJPROP_STYLE,Continious_line_style);
     
     }
   } else
   {
     if (((Val+Forex_shift*Point) <= myprice) && (myprice <= (Vah+Forex_shift*Point)))
     { 
       // inside VA
       ObjectSet(rec_name,OBJPROP_COLOR,LineColor_in_VA);      
     } else
     {
       ObjectSet(rec_name,OBJPROP_COLOR,LineColor_out_VA); 
     }
   }
   if(LineColor_Width<1 || LineColor_Width>3) { LineColor_Width=1; }
   ObjectSet(rec_name,OBJPROP_WIDTH,LineColor_Width); 
   ObjectSet(rec_name,OBJPROP_BACK,Draw_as_Background);
   ObjectSetText(rec_name, "Price: "+DoubleToStr(NormalizeDouble(myprice,Digits),Digits)+"\nVolume: "+showvol+"\nWeight: "+DoubleToStr(showvol*100.0/mymaxvol,2)+"%");
}



int check_VA(double& val,double& vah, double max_volume_price,double max_volume_index,double &ps[], double &vol[])
{
  int i=0;
  double total_volume=0;
  double deviation_volume=0;
  double calculate=0;
  double v_above=0, v_bellow=0;
  int i_above=ArraySize(vol)-1; 
  int i_bellow=0;
  
  for (i=0; i<ArraySize(vol); i++)
  {
    total_volume=total_volume + vol[i];
  }
  
  deviation_volume = 0.31 * total_volume;

  while(calculate < deviation_volume)
  {
     vah=ps[i_above];
     val=ps[i_bellow];                   
     if (v_above <= v_bellow)
     {
       v_above = v_above + vol[i_above];
       i_above--;
       
     }  else
     {
       v_bellow = v_bellow + vol[i_bellow];
       
       i_bellow++;
       
     }
     calculate = v_above+v_bellow;
  }

  return (0);
}

string UrlEncode(string url)
{
  string out = "";
  int len    = StringLen(url);
  
  for (int i = 0; i < len; i++) {
    int c = StringGetChar(url, i);
    if (_IsReservedChar(c)) {
      out = StringConcatenate(out, "%", StringSubstr(IntegerToHexString(c), 6, 2));
    }
    else {
      out = StringConcatenate(out, StringSubstr(url, i, 1)); 
    }
  }
  return (out);
}


bool _IsReservedChar(int c) 
{
  static int encode[] = { '!', '*', 0x27 , '(', ')', ';', ':', '@', 
                          '&', '=', '+', '$', '/', '?', '#', '[', ']' };
  for (int i = ArraySize(encode) - 1; i >= 0; i--) {
    if (c == encode[i]) {
      return (true);
    }
  }
  return (false);
}


//+----------------------------------------------------------------------------+
//|    :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
int ConvertResponseToArrays(string st, double& td[],double& vd[], string de1, string de2, string& msg, datetime& Server_StartTime, datetime& Server_StopTime) { 
//ConvertResponseToArrays(response,TimeDate,ValueDate,"\n",";");
  int    i=0, np, dp;
  string stp,dtp,dtv;

  ArrayResize(td, 0);
  ArrayResize(vd, 0);
  
  
  
  
  np=StringFind(st, de1);
  if(np>0)
  {
      stp=StringSubstr(st, 0, np); // Message from server
      msg=stp;
      st=StringSubstr(st, np+1);
  }
  
  np=StringFind(st, de1);
  if(np>0)
  {
      stp=StringSubstr(st, 0, np); // Message from server
      
      dp=StringFind(stp, de2);
      dtp=StringSubstr(stp,0,dp);
      //mmin_price=StrToDouble(dtp); 
      stp=StringSubstr(stp, dp+1);
      dp=StringFind(stp, de2);
      dtp=StringSubstr(stp,0,dp);
      Server_StartTime=StrToTime(dtp); 
      dtp=StringSubstr(stp, dp+1);
      Server_StopTime=StrToTime(dtp); 
      st=StringSubstr(st, np+1);
  }
  //Print(TimeToStr(Server_StartTime));
  while (StringLen(st)>0 && np>0) {
    np=StringFind(st, de1);

    if (np<0) {
      stp=st;
      st="";
    } else {
      stp=StringSubstr(st, 0, np);
      st=StringSubstr(st, np+1);
    }
    

    dp=StringFind(stp, de2);
    if(dp<0)
    {
      //     
      dtp="0";
      dtv="0";      
    } else 
    {
      dtp=StringSubstr(stp, 0, dp);
      dtv=StringSubstr(stp, dp+1);

    }
    
    
    ArrayResize(td, i+1);
    ArrayResize(vd, i+1);
    td[i]= StrToDouble(dtp);
    vd[i]= StrToDouble(dtv);
    i++;
  }
  return(ArraySize(td));
}
 

void SortDictionary(double &keys[], double &values[], 
                    int sortDirection = MODE_ASCEND, int multiple=1)
{
   double keyCopy[];
   double valueCopy[];
   ArrayCopy(keyCopy, keys);
   ArrayCopy(valueCopy, values);
   ArraySort(keys, WHOLE_ARRAY, 0, sortDirection);
   Sleep(10);
   
   for (int i = 0; i < MathMin(ArraySize(keys), ArraySize(values)); i++)
   {
      //values[i] = valueCopy[ArrayBsearch(keyCopy, keys[i])];
      values[ArrayBsearch(keys, keyCopy[i])] = valueCopy[i]*multiple;
   }
  
}

void ReversePrices(double &keys[],bool no_reverse=false,int multiple=1)
{
  for (int i = 0; i < ArraySize(keys); i++)
  {
     if (no_reverse == false)
     {
       keys[i] = NormalizeDouble(1/keys[i],Digits);
     }
     keys[i] = multiple * keys[i];
  }
}


